/*  bdf     .   */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "config.h"

image *font=NULL;

int
readFont(char *name, int dbl)
{ FILE *f;
  char buf[1000];
  int code=-1;
  unsigned cw;

  font=malloc(sizeof(image)*256);
  if(!font) return 1;
  for(cw=0; cw!=256; cw++)
   { font[cw].width=font[cw].height=0;
     font[cw].rows=NULL;
   }
  f=fopen(name,"r");
  if(!f) return 2;
  while(fgets(buf,1000,f))
   { if(!strncasecmp(buf,"startchar ",10))
      { if(code!=-1) return 3;
      }
     if(!strncasecmp(buf,"encoding ",9))
      { if(code!=-1) return 4;
        code=strtol(buf+9,NULL,10);
        if(code<0) { code=-1; continue; }
        font[code].width=font[code].height=0;
        font[code].rows=NULL;
        cw=0;
      }
     if(!strncasecmp(buf,"dwidth ",7))
      { cw=strtol(buf+7,NULL,10);
      }
     if(!strncasecmp(buf,"bitmap",6) && code!=-1)
      { unsigned x,y=0;
        if(!cw) return 5;
        while(fgets(buf,1000,f) && strncasecmp(buf,"endchar",7))
         { for(x=0; x!=cw; x++)
            { unsigned color=tolower(buf[x/4]);
              if(!isxdigit(color)) return 6;
              color=isdigit(color) ? color-'0' : color-'a'+10;
              if(x) color=color << (x%4);
              color=(color&8)/8;
              if(dbl)
               { putPixel(font+code,x*2,y*2,color);
                 putPixel(font+code,x*2+1,y*2,color);
                 putPixel(font+code,x*2,y*2+1,color);
                 putPixel(font+code,x*2+1,y*2+1,color);
               }
              else
               putPixel(font+code,x,y,color);

            }
           y++;
         }
        if(!y || feof(f)) return 7;
        code=-1;
      }
   }
  fclose(f);
  return 0;
}
